%%:- fsa_regex:fsa_load_aux_file(eacl99).
:- ensure_loaded(replace).
%%:- fsa_regex:fsa_load_aux_file(replace_nm).

%%:- fsa_regex:compile(replace).

:- multifile rx/2.
:- multifile macro/2.


macro(soundex_rules, 
     {
          {b,f,p,v}+       x 1,
       {c,g,j,k,q,s,x,z}+  x 2,
             {d,t}+        x 3,
                l+         x 4,
            {m,n}+         x 5,
                r+         x 6, 
       {a,e,h,i,o,u,w,y}+  x []
      }).

macro(soundex,
      replace(soundex_rules)
                o
   {[?,?,?,?,(? :[])*],
    [?,?,?,[]:0],
    [?,?,[] x [0,0]], 
    [?,[] x [0,0,0]]}
     ).


%% In order to create an executable that computes soundex codes
%% line by line, you can do:
%%
%% fsa write=c -aux soundex -r soundex > soundex.c
%% cc soundex.c -o soundex

