#!/usr/local/bin/perl
##
# Convert xfst script files into a version acceptable by
# xfst2fsa
#
# By Shlomo Yona <shlomo@cs.haifa.ac.il>
##
use strict;
usage("Invalid commandline arguments\n") unless @ARGV==2;
my $infile=shift @ARGV;
my $outfile=shift @ARGV;
open(IN,"<$infile") or die "Cannot open $infile for reading: $!\n";
open (OUT,">$outfile") or die "Cannot open $outfile for writing: $!\n";
my @v=();
my $t='';
while(<IN>) {
	s/^\s//;
	s/[ \t\r]+/ /g;
	if (not /^\s*!/) {
		s/\%\'/\%^/g;
		s/(?<!\%)\'/\%^/g;
		s/(?<!\%)!/\n!/g;
	}
#	s/^/!/ if not /^\s*(?:define|(?:read)?\s+regex|!)/;
	$t.=$_;
	/^\s*define\s+(\w+)/;
	push @v,$1 if defined $1;
}
for my $var (@v) { $t=~s/(\b)($var)(\b)/$1xxx$2$3/gs; }
close(IN) or die "Cannot close $infile after reading: $!\n";
if ($t!~/\n\s*read\s+regex\s+end\s*;\s*\ns\*$/) {
	$t.="\nread regex end;\n";
}
print OUT $t;
close(OUT) or die "Cannot close $outfile after writing: $!\n";
exit(0);
sub usage {
	die qq{
$0

USAGE:
	$0 inputfile outputfile

inputfile	should be a valid xfst script file.
outputfile	is the name of the file where the corrected 
		xfst script file will be written into.

DIAGNOSTICS:
	@_
	\n};
}
