
%{
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "typedef.h"
#define yyerror(x) { printf("%s in line %d\n",x,line_number);}

NODE root;
int line_number=1;
extern int yylex(void);
NODE MakeNode(int op, NODE s1, NODE s2,char *str);

%}

%union
   { char *string;
     NODE node;
   }

%token T_BACKSLASH T_TILDE T_PLUS T_ASTERISK T_DOLAR T_OR T_AND T_MINUS T_SLASH T_BOUND
%token T_LEFT_ROUND_BRACKET T_RIGHT_ROUND_BRACKET T_LEFT_RECT_BRACKET T_RIGHT_RECT_BRACKET
%token T_LESS T_MORE T_REVERSE T_CROSSPRODUCT T_COMPOSITION T_COLON T_DOMAIN T_RANGE T_INVERT
%token T_UNDERSCORE T_COMMA T_REPLACE T_TWO_OR T_DOUBLE_COMMA T_RESTRICT T_SLASH_PERIOD T_DOLAR_QUESTION
%token T_REGEX T_END T_MARKUP T_BACKSLASH_SLASH T_TWO_SLASH T_TWO_BACKSLASH 
%token T_SHORTEST_REPLACE T_LONGEST_REPLACE T_SHORTEST_REPLACE_RL T_LONGEST_REPLACE_RL
%token<string> T_CHAR_CONCATENATION T_ANY_SYMBOL T_ONE_SYMBOL T_EPSILON T_OTHER T_DOLAR_PERIOD T_REMARK T_OTHER_NO_QUOTES T_OTHER_QUOTES T_DEFINE
%token<string> T_N_CONCATENATION T_N_K_CONCATENATION T_MORE_N_CONCATENATION T_LESS_N_CONCATENATION
%type<node> code basic_expr symbol context regex remark begin_code define markup_context 
%type<node> longest_replace longest_replace_rl shortest_replace shortest_replace_rl
%type<node> rule_longest rule_longest_rl rule_shortest rule_shortest_rl
%type<node> replace_longest_or_or replace_longest_sl_sl replace_longest_bsl_bsl replace_longest_bsl_sl
%type<node> replace_longest_rl_or_or replace_longest_rl_sl_sl replace_longest_rl_bsl_bsl replace_longest_rl_bsl_sl
%type<node> replace_shortest_or_or replace_shortest_sl_sl replace_shortest_bsl_bsl replace_shortest_bsl_sl
%type<node> replace_shortest_rl_or_or replace_shortest_rl_sl_sl replace_shortest_rl_bsl_bsl replace_shortest_rl_bsl_sl
%type<node> rule rule_option rule_double rule_double_option rule_reverse rule_reverse_option
%type<node> replace replace_or_or replace_sl_sl replace_bsl_bsl replace_bsl_sl
%type<node> replace_option replace_option_or_or replace_option_sl_sl replace_option_bsl_bsl replace_option_bsl_sl
%type<node> replace_double replace_double_or_or replace_double_sl_sl replace_double_bsl_bsl replace_double_bsl_sl
%type<node> replace_double_option replace_double_option_or_or replace_double_option_sl_sl replace_double_option_bsl_bsl replace_double_option_bsl_sl
%type<node> replace_reverse replace_reverse_or_or replace_reverse_sl_sl replace_reverse_bsl_bsl replace_reverse_bsl_sl
%type<node> replace_reverse_option replace_reverse_option_or_or replace_reverse_option_sl_sl replace_reverse_option_bsl_bsl replace_reverse_option_bsl_sl
%type<node> expr10 expr9 expr8 expr7 expr6 expr5 expr4 expr3 expr1
%type<node> rel10 rel9 rel8 rel6 rel4 rel2 

%nonassoc T_LEFT_RECT_BRACKET T_LEFT_ROUND_BRACKET
%left T_CROSSPRODUCT T_COMPOSITION
%left T_DOUBLE_COMMA
%nonassoc T_TWO_OR T_BACKSLASH_SLASH T_TWO_SLASH T_TWO_BACKSLASH
%left T_RESTRICT
%left T_COMMA
%left T_REPLACE T_OPTION_REPLACE T_REV_REPLACE T_OPTION_REV_REPLACE T_DOUBLE_REPLACE T_OPTION_DOUBLE_REPLACE T_LONGEST_REPLACE T_LONGEST_REPLACE_RL T_SHORTEST_REPLACE T_SHORTEST_REPLACE_RL
%left T_UNDERSCORE T_MARKUP 
%left T_OR T_AND T_MINUS
%left T_MORE T_LESS
%left T_SLASH T_SLASH_PERIOD
%left T_PLUS T_ASTERISK T_N_CONCATENATION T_N_K_CONCATENATION T_MORE_N_CONCATENATION T_LESS_N_CONCATENATION T_RANGE T_DOMAIN T_INVERT T_REVERSE
%right T_TILDE T_BACKSLASH T_DOLAR T_DOLAR_PERIOD T_DOLAR_QUESTION
%left T_COLON

%start  begin_code

%%
begin_code:	code						{$$=MakeNode(BEGIN_CODE,$1,NULL,0); root=$$}
;
code:	regex							{$$=MakeNode(CODE,$1,NULL,0);}
	|	remark code						{$$=MakeNode(CODE,$1,$2,0);}
	|	define code						{$$=MakeNode(CODE,$1,$2,0);}
;
remark:	T_REMARK						{$$=MakeNode(REMARK,NULL,NULL,$1);}
;
regex:	T_REGEX expr10 T_END			{$$=MakeNode(REGEX,$2,NULL,0);}							
	|	T_REGEX rel10 T_END				{$$=MakeNode(REGEX,$2,NULL,0);}	
	|	T_REGEX error T_END				{yyerrok;}							
;
define:	T_DEFINE expr10 T_END			{$$=MakeNode(DEFINE,$2,NULL,$1);}
	|	T_DEFINE rel10 T_END			{$$=MakeNode(DEFINE,$2,NULL,$1);}	
	|	T_DEFINE error T_END			{$$=MakeNode(ERROR,NULL,NULL,0);yyerrok;}	
;
expr10:	expr9
	 |	expr10 T_COMPOSITION expr10		{$$=MakeNode(COMPOSITION,$1,$3,0);}
;
expr9:	expr8
	 |	expr9 T_RESTRICT context		{$$=MakeNode(RESTRICT,$1,$3,0);}		
;
expr8:	expr7
	 |  expr8 T_OR expr8				{$$=MakeNode(UNION_EXPR,$1,$3,0);}				
	 |  expr8 T_AND expr8				{$$=MakeNode(INTERSECTION_EXPR,$1,$3,0);}	
	 |	expr8 T_MINUS expr8				{$$=MakeNode(MINUS,$1,$3,0);}
;
expr7:	expr6
	 |	expr7 T_LESS expr7				{$$=MakeNode(BEFORE,$1,$3,0);}
	 |	expr7 T_MORE expr7				{$$=MakeNode(AFTER,$1,$3,0);}
	 |	expr7 T_LESS T_MORE expr7		{$$=MakeNode(SHUFFLE,$1,$4,0);}
;
expr6:	expr5 
	 |	expr6 expr5						{$$=MakeNode(CONCATENATION_EXPR,$1,$2,0);}						
;
expr5:	expr4
	 |	expr5 T_SLASH expr5				{$$=MakeNode(IGNORE,$1,$3,0);}
	 |	expr5 T_SLASH_PERIOD expr5 		{$$=MakeNode(INTERNAL_IGNORE,$1,$3,0);}
;
expr4:	expr3
	 |	expr4 T_PLUS					{$$=MakeNode(KLEENE_PLUS,$1,NULL,0);}
	 |	expr4 T_ASTERISK				{$$=MakeNode(KLEENE_STAR,$1,NULL,0);}	
	 |	expr4 T_N_CONCATENATION			{$$=MakeNode(N_CONCATENATION,$1,NULL,$2);}
	 |	expr4 T_N_K_CONCATENATION		{$$=MakeNode(N_K_CONCATENATION,$1,NULL,$2);}
	 |  expr4 T_MORE_N_CONCATENATION	{$$=MakeNode(MORE_N_CONCATENATION,$1,NULL,$2);}	
	 |  expr4 T_LESS_N_CONCATENATION	{$$=MakeNode(LESS_N_CONCATENATION,$1,NULL,$2);}	
	 |	expr4 T_REVERSE					{$$=MakeNode(REVERSE,$1,NULL,0);}
	 |	expr4 T_DOMAIN					{$$=MakeNode(DOMAIN,$1,NULL,0);}
	 |	expr4 T_RANGE					{$$=MakeNode(RANGE,$1,NULL,0);}
	 |	rel4 T_DOMAIN					{$$=MakeNode(DOMAIN,$1,0,0);}				
	 |	rel4 T_RANGE					{$$=MakeNode(RANGE,$1,0,0);}
;
expr3:	expr1
	 |	T_BACKSLASH expr3				{$$=MakeNode(TERM_COMPLEMENT,$2,NULL,0);}
	 |	T_TILDE expr3					{$$=MakeNode(COMPLEMENT,$2,NULL,0);}
 	 |  T_DOLAR expr3					{$$=MakeNode(CONTAINMENT,$2,NULL,0);}
	 |	T_DOLAR_PERIOD expr3			{$$=MakeNode(ONE_CONTAINMENT,$2,NULL,0);}
	 |	T_DOLAR_QUESTION expr3			{$$=MakeNode(MAX_ONE_CONTAINMENT,$2,NULL,0);}
;
expr1:	basic_expr						
	 |	T_LEFT_RECT_BRACKET expr10 T_RIGHT_RECT_BRACKET	{$$=MakeNode(ORDER,$2,NULL,0);}
	 |	T_LEFT_ROUND_BRACKET expr10 T_RIGHT_ROUND_BRACKET	{$$=MakeNode(OPTION,$2,NULL,0);}
;
basic_expr: T_CHAR_CONCATENATION		{$$=MakeNode(CHAR_CONCATENATION,NULL,NULL,$1);}
		  | symbol						
		  | T_OTHER_QUOTES				{$$=MakeNode(OTHER_QUOTES,NULL,NULL,$1);}
		  | T_OTHER_NO_QUOTES			{$$=MakeNode(OTHER_NO_QUOTES,NULL,NULL,$1);}
;
symbol:     T_ANY_SYMBOL				{$$=MakeNode(ANY_SYMBOL,NULL,NULL,0);}
		  | T_ONE_SYMBOL				{$$=MakeNode(ONE_SYMBOL,NULL,NULL,$1);}
		  | T_EPSILON					{$$=MakeNode(EPSILON,NULL,NULL,0);}
;
rel10:	rel9
	 |	expr10 T_CROSSPRODUCT expr10		{$$=MakeNode(CROSSPRODUCT,$1,$3,0);}
	 |	rel10 T_COMPOSITION rel10			{$$=MakeNode(COMPOSITION,$1,$3,0);}
	 |	expr10 T_COMPOSITION rel10		{$$=MakeNode(COMPOSITION,$1,$3,0);}
	 |	rel10 T_COMPOSITION expr10		{$$=MakeNode(COMPOSITION,$1,$3,0);}
;
rel9:	rel8
	|	expr9 T_REPLACE markup_context	{$$=MakeNode(MARKUP,$1,$3,0);}
	|	expr9 T_LONGEST_REPLACE markup_context	{$$=MakeNode(LONGEST_MARKUP,$1,$3,0);}
	|	expr9 T_LONGEST_REPLACE_RL markup_context	{$$=MakeNode(LONGEST_MARKUP_RL,$1,$3,0);}
	|	expr9 T_SHORTEST_REPLACE markup_context	{$$=MakeNode(SHORTEST_MARKUP,$1,$3,0);}
	|	expr9 T_SHORTEST_REPLACE_RL markup_context	{$$=MakeNode(SHORTEST_MARKUP_RL,$1,$3,0);}
	|	longest_replace					{$$=MakeNode(LONGEST_REPLACE,$1,NULL,0);}
	|	longest_replace_rl				{$$=MakeNode(LONGEST_REPLACE_RL,$1,NULL,0);}
	|	shortest_replace				{$$=MakeNode(SHORTEST_REPLACE,$1,NULL,0);}
	|	shortest_replace_rl				{$$=MakeNode(SHORTEST_REPLACE_RL,$1,NULL,0);}
	|	replace							{$$=MakeNode(REPLACE,$1,NULL,0);}
	|	replace_option					{$$=MakeNode(REPLACE_OPTION,$1,NULL,0);}
	|	replace_double					{$$=MakeNode(REPLACE_DOUBLE,$1,NULL,0);}
	|	replace_double_option			{$$=MakeNode(REPLACE_DOUBLE_OPTION,$1,NULL,0);}
	|	replace_reverse					{$$=MakeNode(REPLACE_REVERSE,$1,NULL,0);}
	|	replace_reverse_option			{$$=MakeNode(REPLACE_REVERSE_OPTION,$1,NULL,0);}
;
rel8:	rel6
	|	rel8 T_OR rel8					{$$=MakeNode(UNION_REL,$1,$3,0);}
	|	expr8 T_OR rel8					{$$=MakeNode(UNION_REL,$1,$3,0);}
	|	rel8 T_OR expr8					{$$=MakeNode(UNION_REL,$1,$3,0);}
	|	rel8 T_AND rel8					{$$=MakeNode(INTERSECTION_REL,$1,$3,0);}
	|	expr8 T_AND rel8					{$$=MakeNode(INTERSECTION_REL,$1,$3,0);}
	|	rel8 T_AND expr8					{$$=MakeNode(INTERSECTION_REL,$1,$3,0);}
;
rel6:	rel4
	|	rel6 rel4						{$$=MakeNode(CONCATENATION_REL,$1,$2,0);}
	|	rel6 expr5						{$$=MakeNode(CONCATENATION_REL,$1,$2,0);}
	|	expr6 rel4						{$$=MakeNode(CONCATENATION_REL,$1,$2,0);}
;
rel4:	rel2
	 |	rel4 T_PLUS						{$$=MakeNode(KLEENE_PLUS,$1,NULL,0);}
	 |	rel4 T_ASTERISK					{$$=MakeNode(KLEENE_STAR,$1,NULL,0);}	
     |	rel4 T_INVERT					{$$=MakeNode(INVERT,$1,NULL,0);}
	 |	expr4 T_INVERT					{$$=MakeNode(INVERT_EXPR,$1,NULL,0);}
;
rel2:	symbol T_COLON symbol			{$$=MakeNode(PAIR,$1,$3,0);}
	|	T_LEFT_RECT_BRACKET rel10 T_RIGHT_RECT_BRACKET	{$$=MakeNode(ORDER,$2,NULL,0);}
	|	T_LEFT_ROUND_BRACKET rel10 T_RIGHT_ROUND_BRACKET	{$$=MakeNode(OPTION,$2,NULL,0);}
;
context: context T_COMMA context		{$$=MakeNode(MERGE_CONTEXT,$1,$3,0);}
	   | expr9 T_UNDERSCORE expr9				{$$=MakeNode(CONTEXT,$1,$3,0);}
	   | T_BOUND expr9 T_UNDERSCORE expr9			{$$=MakeNode(CONTEXT_START,$2,$4,0);}
	   | T_LEFT_RECT_BRACKET T_BOUND expr9 T_RIGHT_RECT_BRACKET T_UNDERSCORE expr9	{$$=MakeNode(CONTEXT_START,$3,$6,0);}
	   | expr9 T_UNDERSCORE expr9 T_BOUND			{$$=MakeNode(CONTEXT_END,$1,$3,0);}
	   | expr9 T_UNDERSCORE T_LEFT_RECT_BRACKET expr9 T_BOUND T_RIGHT_RECT_BRACKET	{$$=MakeNode(CONTEXT_END,$1,$4,0);}
	   | T_BOUND expr9 T_UNDERSCORE expr9 T_BOUND	{$$=MakeNode(CONTEXT_START_END,$2,$4,0);}
	   | T_LEFT_RECT_BRACKET T_BOUND expr9 T_RIGHT_RECT_BRACKET T_UNDERSCORE expr9 T_BOUND	{$$=MakeNode(CONTEXT_START_END,$3,$6,0);}
	   | T_BOUND expr9 T_UNDERSCORE T_LEFT_RECT_BRACKET expr9 T_BOUND T_RIGHT_RECT_BRACKET	{$$=MakeNode(CONTEXT_START_END,$2,$5,0);}
	   | T_LEFT_RECT_BRACKET T_BOUND expr9 T_RIGHT_RECT_BRACKET T_UNDERSCORE T_LEFT_RECT_BRACKET expr9 T_BOUND	T_RIGHT_RECT_BRACKET	{$$=MakeNode(CONTEXT_START_END,$3,$7,0);}
	   | expr9 T_UNDERSCORE						{$$=MakeNode(RIGHT_CONTEXT,$1,NULL,0);}
	   | T_BOUND expr9 T_UNDERSCORE					{$$=MakeNode(RIGHT_CONTEXT_START,$2,NULL,0);}
	   | T_LEFT_RECT_BRACKET T_BOUND expr9 T_RIGHT_RECT_BRACKET T_UNDERSCORE	{$$=MakeNode(RIGHT_CONTEXT_START,$3,NULL,0);}
	   | expr9 T_UNDERSCORE T_BOUND					{$$=MakeNode(RIGHT_CONTEXT_END,$1,NULL,0);}
	   | T_BOUND expr9 T_UNDERSCORE	T_BOUND			{$$=MakeNode(RIGHT_CONTEXT_START_END,$2,NULL,0);}
	   | T_LEFT_RECT_BRACKET T_BOUND expr9 T_RIGHT_RECT_BRACKET T_UNDERSCORE T_BOUND	{$$=MakeNode(RIGHT_CONTEXT_START_END,$3,NULL,0);}
	   | T_UNDERSCORE expr9						{$$=MakeNode(LEFT_CONTEXT,$2,NULL,0);}
	   | T_BOUND T_UNDERSCORE expr9					{$$=MakeNode(LEFT_CONTEXT_START,$3,NULL,0);}
	   | T_UNDERSCORE expr9 T_BOUND					{$$=MakeNode(LEFT_CONTEXT_END,$2,NULL,0);}
	   | T_UNDERSCORE T_LEFT_RECT_BRACKET expr9 T_BOUND	T_RIGHT_RECT_BRACKET	{$$=MakeNode(LEFT_CONTEXT_END,$3,NULL,0);}
	   | T_BOUND T_UNDERSCORE expr9	T_BOUND			{$$=MakeNode(LEFT_CONTEXT_START_END,$3,NULL,0);}
	   | T_BOUND T_UNDERSCORE T_LEFT_RECT_BRACKET expr9	T_BOUND	T_RIGHT_RECT_BRACKET	{$$=MakeNode(LEFT_CONTEXT_START_END,$4,NULL,0);}
	   | T_UNDERSCORE							{$$=MakeNode(EMPTY_CONTEXTS,NULL,NULL,0);}
	   | T_BOUND T_UNDERSCORE						{$$=MakeNode(EMPTY_CONTEXTS_START,NULL,NULL,0);}
	   | T_UNDERSCORE T_BOUND						{$$=MakeNode(EMPTY_CONTEXTS_END,NULL,NULL,0);}
	   | T_BOUND T_UNDERSCORE T_BOUND				{$$=MakeNode(EMPTY_CONTEXTS_START_END,NULL,NULL,0);}
;	   
markup_context:	expr9 T_MARKUP expr9	{$$=MakeNode(MARKUP_CONTEXT,$1,$3,0);}
;
replace: rule							{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_or_or					{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_sl_sl					{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_bsl_bsl				{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_bsl_sl					{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_or_or: rule T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_or_or T_DOUBLE_COMMA replace_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_sl_sl: rule T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_sl_sl T_DOUBLE_COMMA replace_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_bsl_bsl: rule T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_bsl_bsl T_DOUBLE_COMMA replace_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_bsl_sl: rule T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_bsl_sl T_DOUBLE_COMMA replace_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule:	 expr9 T_REPLACE expr9 			{$$=MakeNode(RULE,$1,$3,0);}
	   | rule T_COMMA rule				{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
replace_option: rule_option				{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_option_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_option_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_option_bsl_bsl			{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_option_bsl_sl			{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_option_or_or: rule_option T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_option_or_or T_DOUBLE_COMMA replace_option_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_option_sl_sl: rule_option T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_option_sl_sl T_DOUBLE_COMMA replace_option_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_option_bsl_bsl: rule_option T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_option_bsl_bsl T_DOUBLE_COMMA replace_option_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_option_bsl_sl: rule_option T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_option_bsl_sl T_DOUBLE_COMMA replace_option_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_option:	 expr9 T_OPTION_REPLACE expr9 		{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_option T_COMMA rule_option			{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
replace_double: rule_double				{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_double_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_double_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_double_bsl_bsl			{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_double_bsl_sl			{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_double_or_or: rule_double T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_or_or T_DOUBLE_COMMA replace_double_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_sl_sl: rule_double T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_sl_sl T_DOUBLE_COMMA replace_double_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_bsl_bsl: rule_double T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_bsl_bsl T_DOUBLE_COMMA replace_double_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_bsl_sl: rule_double T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_bsl_sl T_DOUBLE_COMMA replace_double_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_double:	 expr9 T_DOUBLE_REPLACE expr9 		{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_double T_COMMA rule_double			{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
replace_double_option: rule_double_option	{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_double_option_or_or		{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_double_option_sl_sl		{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_double_option_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_double_option_bsl_sl		{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_double_option_or_or: rule_double_option T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_option_or_or T_DOUBLE_COMMA replace_double_option_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_option_sl_sl: rule_double_option T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_option_sl_sl T_DOUBLE_COMMA replace_double_option_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_option_bsl_bsl: rule_double_option T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_option_bsl_bsl T_DOUBLE_COMMA replace_double_option_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_double_option_bsl_sl: rule_double_option T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_double_option_bsl_sl T_DOUBLE_COMMA replace_double_option_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_double_option:	 expr9 T_OPTION_DOUBLE_REPLACE expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_double_option T_COMMA rule_double_option		{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
replace_reverse: rule_reverse			{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_reverse_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_reverse_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_reverse_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_reverse_bsl_sl			{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_reverse_or_or: rule_reverse T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_or_or T_DOUBLE_COMMA replace_reverse_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_sl_sl: rule_reverse T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_sl_sl T_DOUBLE_COMMA replace_reverse_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_bsl_bsl: rule_reverse T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_bsl_bsl T_DOUBLE_COMMA replace_reverse_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_bsl_sl: rule_reverse T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_bsl_sl T_DOUBLE_COMMA replace_reverse_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_reverse:	 expr9 T_REV_REPLACE expr9 			{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_reverse T_COMMA rule_reverse			{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
replace_reverse_option: rule_reverse_option		{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_reverse_option_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_reverse_option_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_reverse_option_bsl_bsl			{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_reverse_option_bsl_sl			{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_reverse_option_or_or: rule_reverse_option T_TWO_OR context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_option_or_or T_DOUBLE_COMMA replace_reverse_option_or_or	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_option_sl_sl: rule_reverse_option T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_option_sl_sl T_DOUBLE_COMMA replace_reverse_option_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_option_bsl_bsl: rule_reverse_option T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_option_bsl_bsl T_DOUBLE_COMMA replace_reverse_option_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_reverse_option_bsl_sl: rule_reverse_option T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_reverse_option_bsl_sl T_DOUBLE_COMMA replace_reverse_option_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_reverse_option:	 expr9 T_OPTION_REV_REPLACE expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_reverse_option T_COMMA rule_reverse_option	{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
longest_replace: rule_longest			{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_longest_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_longest_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_longest_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_longest_bsl_sl			{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_longest_or_or: rule_longest T_TWO_OR context {$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_or_or T_DOUBLE_COMMA replace_longest_or_or	 {$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_sl_sl: rule_longest T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_sl_sl T_DOUBLE_COMMA replace_longest_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_bsl_bsl: rule_longest T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_bsl_bsl T_DOUBLE_COMMA replace_longest_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_bsl_sl: rule_longest T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_bsl_sl T_DOUBLE_COMMA replace_longest_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_longest:	 expr9 T_LONGEST_REPLACE expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_longest T_COMMA rule_longest		{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
longest_replace_rl: rule_longest_rl		{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_longest_rl_or_or		{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_longest_rl_sl_sl		{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_longest_rl_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_longest_rl_bsl_sl		{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_longest_rl_or_or: rule_longest_rl T_TWO_OR context {$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_rl_or_or T_DOUBLE_COMMA replace_longest_rl_or_or	 {$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_rl_sl_sl: rule_longest_rl T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_rl_sl_sl T_DOUBLE_COMMA replace_longest_rl_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_rl_bsl_bsl: rule_longest_rl T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_rl_bsl_bsl T_DOUBLE_COMMA replace_longest_rl_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_longest_rl_bsl_sl: rule_longest_rl T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_longest_rl_bsl_sl T_DOUBLE_COMMA replace_longest_rl_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_longest_rl:	 expr9 T_LONGEST_REPLACE_RL expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_longest_rl T_COMMA rule_longest_rl		{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
shortest_replace: rule_shortest			{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_shortest_or_or			{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_shortest_sl_sl			{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_shortest_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_shortest_bsl_sl		{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_shortest_or_or: rule_shortest T_TWO_OR context {$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_or_or T_DOUBLE_COMMA replace_shortest_or_or	 {$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_sl_sl: rule_shortest T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_sl_sl T_DOUBLE_COMMA replace_shortest_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_bsl_bsl: rule_shortest T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_bsl_bsl T_DOUBLE_COMMA replace_shortest_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_bsl_sl: rule_shortest T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_bsl_sl T_DOUBLE_COMMA replace_shortest_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_shortest:	 expr9 T_SHORTEST_REPLACE expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_shortest T_COMMA rule_shortest		{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;
shortest_replace_rl: rule_shortest_rl		{$$=MakeNode(NO_CONTEXT,$1,NULL,0);}
	   | replace_shortest_rl_or_or		{$$=MakeNode(OR_OR,$1,NULL,0);}
	   | replace_shortest_rl_sl_sl		{$$=MakeNode(SL_SL,$1,NULL,0);}
	   | replace_shortest_rl_bsl_bsl		{$$=MakeNode(BSL_BSL,$1,NULL,0);}
	   | replace_shortest_rl_bsl_sl		{$$=MakeNode(BSL_SL,$1,NULL,0);}
;
replace_shortest_rl_or_or: rule_shortest_rl T_TWO_OR context {$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_rl_or_or T_DOUBLE_COMMA replace_shortest_rl_or_or	 {$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_rl_sl_sl: rule_shortest_rl T_TWO_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_rl_sl_sl T_DOUBLE_COMMA replace_shortest_rl_sl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_rl_bsl_bsl: rule_shortest_rl T_TWO_BACKSLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_rl_bsl_bsl T_DOUBLE_COMMA replace_shortest_rl_bsl_bsl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
replace_shortest_rl_bsl_sl: rule_shortest_rl T_BACKSLASH_SLASH context		{$$=MakeNode(REPLACE_RULE_CONTEXT,$1,$3,0);}
	   | replace_shortest_rl_bsl_sl T_DOUBLE_COMMA replace_shortest_rl_bsl_sl	{$$=MakeNode(MERGE_REPLACE,$1,$3,0);}
;
rule_shortest_rl:	 expr9 T_SHORTEST_REPLACE_RL expr9 	{$$=MakeNode(RULE,$1,$3,0);}
	   | rule_shortest_rl T_COMMA rule_shortest_rl		{$$=MakeNode(MERGE_RULE,$1,$3,0);}
;

%%

/* Tree construction part */
NODE MakeNode(int op, NODE child1, NODE child2,char *str)
{   int i=0;
	NODE tmp;
	tmp= (NODE )malloc(sizeof(struct node));
	tmp->op=op;
	tmp->child1 = child1;
	tmp->child2 = child2;
	tmp->str=str; 
	if (child1!=NULL)
		i++;
    if (child2!=NULL)
	    i++;
	tmp->children=i;
	return(tmp);
}

