%% simple example patterns
%pattern(g2sp).
%pattern(gs1p).
%pattern('1s').
%pattern('.aan5').

%% test with:
%%%% drugspand  --> drugs-pand
%%%% hangsla    --> hang-sla

:- multifile macro/2.

:- ensure_loaded(patterns).
:- ensure_loaded(auxs).

macro(insert_digits(L), range( L o cache(insert_digits) )).

macro(insert_digits, { [] , [[ ? , [] x 0..5]*, ? ] }).

macro(lowest_digits(R),pragma([R0-R],
            R0 - range( higher_digits(R0) ))).

macro(higher_digits(R),R o [ [? , optinc]*,
	                     [? , oblinc],
                             [? , optinc]*,
			      ?
			   ]).

macro(optinc,{ 0 x 0..5, 
	       1 x 1..5,
               2 x 2..5,
               3 x 3..5,
               4 x 4..5,
               5 x 5     }).

macro(oblinc,{ 0 x 1..5,
               1 x 2..5,
               2 x 3..5,
               3 x 4..5, 
               4 x    5  }).

%% '.' in patterns refers to either beginning or end of the word
macro(hyphenate,
         [[]: '.', ? *, []: '.']
                   o
             insert_digits
                   o
     lowest_digits(spy(constraints))
                   o
           digits_to_hyphens
                   o
         ['.' :[], ? *, '.' :[]]  ).

%% odd: no hyphen
%% even: a hyphen
macro(digits_to_hyphens,
         [[ ? , {{0,2,4} x [],
                 {1,3,5} x '-'} ]* ,? ]).

macro(constraints, intersect_list(Cs)) :-
    findall(C, hyphen_constraint(C), Cs).

%% this adds redundant information for efficiency. The redundant
%% information is the `marked' part.
simple_constraint(L,D,R,
      cache(marked) -  $ [   insert_digits(L),
			     0..D1,
			     insert_digits(R) ] 
     ):-
   D1 is D-1.

macro(marked,[[`0..5,0..5]*,`0..5]).

hyphen_constraint(Expr) :-
    constraint(L,N,R),
    simple_constraint(L,N,R,Expr).

