:- multifile macro/2.

%%% Attempt to implement Lauri Karttunen, Directed Replacement,
%%% ACL 1996.
%%% left-to-right, longest match.
:- op(402,yfx,(=>)).
:- op(402,yfx,(<=)).


:- op(403,yfx,'@->').

%% figure 6.
macro(Phi0 @-> Psi, pragma([Phi-Phi0],
      initial(Phi)
          o
      left_to_right(Phi)
          o
      longest_match(Phi)
          o
      replacement(Psi)
     )).

%% figure 4.
macro(fig4, {[a,b],b,[b,a],[a,b,a]} @-> x).

%% figure 11.
%% every Phi is marked with a  dak  to the left.
%% this is different, since we don't have [. .] operator.
%% to mimic [. .] we first introduce special | marker between
%% every two characters, and then replace this special symbol
%% finally, remove | again.
macro(initial(Phi),  ~ $ {'|', dak  ,  lbr , rbr  } 
                             o
                    [[] x '|',[identity(?),[] x '|']*] 
			     o
                    replace_upward('|', dak ,[],ignore(Phi,'|'))
                             o
                          '|' => [] 
     ).

macro(left_to_right(Upper),
      [[ ~ $  dak , [ dak  :  lbr , ignorex(Upper, dak ), []: rbr  ]]*, ~ $  dak ]
                            o
                          dak  => []  
     ).

macro(longest_match(Upper),
      ~ $ [ lbr ,ignorex(Upper,{ lbr , rbr }) & $ rbr  ]
     ).

macro(replacement(Lower),
      [ lbr ,~ $ rbr , rbr ] => Lower
     ).

%% figure 10, slightly generalized.
macro(ignorex(L,I),ignore(L,I) - [? *, I]).

macro(fig12,[a+,b] @-> x).


%% section 3.
%% this is Phi @-> Left ... Right
%% i.e. 
macro(markup(Phi0,Left,Right), pragma([Phi-Phi0],
      initial(Phi)
          o
      left_to_right(Phi)
          o
      longest_match(Phi)
          o
      insertion(Left,Right)
)).

%% figure 13.
%% composition is similar as parallel replacement here.
macro(insertion(Prefix,Suffix),
       lbr => Prefix o
      rbr  => Suffix
     ).

%% figure 14.
macro(fig14,markup([d^,a*,n+],'[',']')).

%% figure 20.
macro(fig20, markup(np,'[NP',']')
                     o
             markup(vp,'[VP',']')
     ).

macro(np,[d^,a*,n+]).
macro(vp,[v,'[NP',np,']']).

:- ensure_loaded('../Karttunen95/operators').
