:- multifile macro/2.

:- op(402,yfx,(=>)).
:- op(402,yfx,(<=)).

%%% This replacement algorithm works by generating and testing. The
%%% first step is to insert brackets {<,>} randomly. Then test that
%%% that the right contexts are marked by a '>', perform the
%%% replacement and then check that the left contexts are followed by
%%% a '<'. 

macro(replace(Upper,Lower,Left,Right),  
            insert_brackets
                   o
            constrain_brackets
                   o
            right_context(Right)
                   o
  [<,ignore(Upper,{<,>}),>]  => [<,ignore(Lower,{<,>}),>] 
                   o
            left_context(Left)
                   o
            remove_brackets).

%%% This defines simple (uncontexted) replacement. Note: '$' means
%%% "contains", '~' means "complement"
%%% Coercion to an identity transducer is implicit.

macro(Upper => Lower,
      [[ ~ $ (Upper - []) , Upper x Lower ] *,~ $ (Upper - [])]). 

macro(remove_brackets,{<,>} => []).

macro(insert_brackets,inverse(remove_brackets)).

macro(constrain_brackets, ~ $ [<,>]).

macro(if_p_then_s(L1,L2), ~ [L1,~L2]).

macro(if_s_then_p(L1,L2), ~ [~L1,L2]).

macro(p_iff_s(L1,L2),minimize(
      if_p_then_s(L1,L2)
	    &
      if_s_then_p(L1,L2))
     ).

macro(left_context(Left),
      p_iff_s(ignore([? *,Left],{<,>}) - [? *,<], [<,? *])
     ).
                                                                   
macro(right_context(Right),                                  
      p_iff_s([? *,>], ignore([Right,? *],{<,>}) - [>,? *])
     ).
