%% (c) 2000 Dale Gerdemann, Gertjan van Noord; available under GPL
%%
%% This is an alternative implementation of syllabification in
%% Optimality Theory (compare with Karttunen, 'The Proper Treatment of 
%% Optimality in Computational Phonology'.
%%
%% Instead of *counting* the number of constraint violations, we
%% match (and delete) all candidates that can be constructed from
%% a candidate by introducing any further constraint violations. This
%% is not equivalent, but is often more accurate. The resulting
%% automata are much smaller too.

:- multifile macro/2.

:- ensure_loaded(utils).

macro(add_violation(N), 
      {output : [], ? - output}*
                     o
           [[? *,[]: @ ]+, ? *]
                     o
             permute_marker(N)
                     o
      {[] : output, ? - output}*
     ).

macro(permute_marker(0), ? *).
macro(permute_marker(N), cache(permute_marker) o permute_marker(N1)) :-
    N>0, N1 is N-1.

macro(permute_marker,
      [{[? *,  @ : [], ? *, [] : @ ],
	[? *, [] : @ , ? *,  @ : []]}*, ? *]).

macro(Input oo Precision :: Constraint,oo(Input,Precision,Constraint)).
macro(Input oo              Constraint,oo(Input,0,        Constraint)).

macro(oo(Input,Precision,Constraint),
                          pragma([V-(Input o mark_ot_constraint(Constraint,@))],
                    V
                    o
             ~ range(  V
		       o
		  add_violation(Precision)
		    )
                    o
             { @ : [],? -  @ }*		 
		    )).

