:- module( fsa_preds_i, []).

:- fsa_globals:fsa_host_prolog(Prolog),
    (   Prolog == swi
    ->  style_check([-(atom)])
    ;	true
    ).

true(not_in([])).

regex_notation_to_predicate(Atom,in([Atom])).

evaluate_predicate(Pred,Symbol) :-
    fsa_preds:evaluate_predicate0(Pred,Symbol).

talks_about(Pred,Symbol) :-
    fsa_preds:talks_about0(Pred,Symbol).

disjunction(Pa,Pb,Pc) :-
    fsa_preds:disjunction0(Pa,Pb,Pc).

conjunction(Pa,Pb,Pc) :-
    fsa_preds:conjunction0(Pa,Pb,Pc).

negation(Pa,Pb) :-
    fsa_preds:negation0(Pa,Pb).

display_predicate(Pred,Conj) :-
    fsa_preds:display_predicate0(Pred,Conj).

prepare_complement_of_set(_Fa,_).

complement_of_set(Preds,_,Comps):-
    true(True),
    (	conjoin_negated(Preds,True,Comp)
    ->	Comps=[Comp]
    ;   Comps=[]
    ).

conjoin_negated([],Pred,Pred).
conjoin_negated([P0|Preds],P1,Pred) :-
    negation(P0,NotP0),
    conjunction(P1,NotP0,P2),
    conjoin_negated(Preds,P2,Pred).

determinize_preds(U0,U):-
    fsa_determinizer:determinize_preds(U0,U,fsa_preds_i).

t_determinize_preds(U0,U):-
    fsa_t_determinizer:t_determinize_preds(U0,U,fsa_preds_i).

identity(Pred,'$@'(Pred)).

class_to_pred(List0,[in(List)]):-
    sort(List0,List).

negated_class_to_pred(List0,[not_in(List)]):-
    sort(List0,List).

cleanup([],[]).
cleanup([H|T],[Pred]) :-
    cleanup(T,H,Pred).

cleanup([],P,P).
cleanup([H|T],Pred0,Pred) :-
    disjunction(H,Pred0,Pred1),
    cleanup(T,Pred1,Pred).

