%% (c) Gertjan van Noord, 1999

:- multifile macro/2.

%% spell checking: find the word in the dictionary `closest' to a
%% given word. 

%% First, define an example dictionary. 
macro(dict, id({ word(boek),
		 word(roep),
		 word(koek),
		 word(deeg),
		 word(meel) })).



%% Next, we define all strings with Levenshtein distance 1
%% subs/1 del/1 and ins/1 are built-in operators
%% they manipulate input side of transducer to allow one symbol
%% to be substituted/deleted/inserted.

%% 
macro(lev1(X0),pragma([X-X0],
	{subs(X), del(X), ins(X)})).

%% If you're in the dictionary, then OK, otherwise
%% apply lev1. This is Karttunen's priority union:
macro(spell(Y), priority_union(Y, lev1(Y))).
macro(spell,spell(dict)).

%% obviously, we could go on to any specific number. Here's two:
macro(spell2(Y),priority_union(spell,lev1(lev1(Y)))).
macro(spell2,spell2(dict)).

macro(priority_union(Q,R), {Q, ~domain(Q) o R}).

macro(wia,spell(id({word(book),
		    word(look),
		    word(rook),
		    word(took),
		    word(lock),
		    word(rock),
		    word(oak)}))).
