; The name of the installer
Name "Finite State Utilities"

; The file to write
OutFile "InstallFsa.exe"

; The default installation directory
InstallDir C:\fsa
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\fsa "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This will install Fsa on your computer."
; The text to prompt the user to enter a directory
DirText "Choose a directory to install in to (directory names with spaces cause certain problems with the tcl/tk interface):"

LicenseText "Copyright Notice" "ok"
LicenseData ..\..\Copyright

; The stuff to install
Section "Fsa (required)"
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  ; Put file there
  File /r "fsa"
  File /r "library"
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\fsa "Install_Dir" "$INSTDIR"
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\fsa" "DisplayName" "fsa (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\fsa" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"
SectionEnd

Section "Fsa Examples (optional)"
  SetOutPath $INSTDIR\fsa
  File /r "..\..\Examples"
SectionEnd

Section "Fsa Manual (optional)"
  SetOutPath $INSTDIR\fsa
  File /r "..\..\Manual"
SectionEnd

; optional section
Section "Start Menu Shortcuts (optional)"
  CreateDirectory "$SMPROGRAMS\fsa"
; Fsa uninstall
  CreateShortCut "$SMPROGRAMS\fsa\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
; Fsa 
  SetOutPath $INSTDIR\fsa
  CreateShortCut "$SMPROGRAMS\fsa\fsa.lnk" "$INSTDIR\fsa\fsa.exe" "-tk" "$INSTDIR\fsa\fsa.ico"
  CreateShortCut "$SMPROGRAMS\fsa\manualhtml.lnk" "$INSTDIR\fsa\Manual\index.html"
  CreateShortCut "$SMPROGRAMS\fsa\manualpdf.lnk" "$INSTDIR\fsa\Manual\manual.pdf"
  CreateShortCut "$SMPROGRAMS\fsa\manualps.lnk" "$INSTDIR\fsa\Manual\manual.ps"
SectionEnd

; uninstall stuff

UninstallText "This will uninstall fsa. Hit uninstall to continue."

; special uninstall section.
Section "Uninstall"
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\fsa"
  DeleteRegKey HKLM SOFTWARE\fsa
  ; remove files
  Delete $INSTDIR\fsa
  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\fsa\*.*"
  ; remove directories used.
  RMDir /r "$SMPROGRAMS\fsa"
  RMDir /r "$INSTDIR"
SectionEnd

; eof
