set entryfont -adobe-helvetica-bold-r-normal--14-140-*-*-*-*-iso8859-*

# history of regex and string
set current_cmd_no 0
set last_cmd_no 0
set string_current_cmd_no 0
set string_last_cmd_no 0

wm title . {Fsa Utilities; (c) Gertjan van Noord}
wm iconname . FSA
wm geometry . 1000x400
wm minsize . 100 100
frame .menu

menubutton .menu.file -text File -underline 0 -menu .menu.file.m
menubutton .menu.options -text Settings -underline 0 -menu .menu.options.m
menubutton .menu.op -text Operations -underline 0 -menu .menu.op.m
menubutton .menu.viz -text Vizualization -underline 0 -menu .menu.viz.m
menubutton .menu.pro -text Produce -underline 0 -menu .menu.pro.m
menubutton .menu.help -text Help -underline 0 -menu .menu.help.m

menu .menu.file.m
menu .menu.options.m
menu .menu.op.m
menu .menu.viz.m
menu .menu.pro.m
menu .menu.help.m

.menu.file.m add command -label Load -underline 0 \
    -command {
	set filename [tk_getOpenFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_globals:fsa_global_set(regex,undefined))
	    prolog protect(fsa_tk:tk_fsa_file('$filename',started($interp)))
	}
    }
.menu.file.m add command -label LoadAux -underline 4\
    -command {
	set filename [tk_getOpenFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_regex:fsa_load_aux_file('$filename'))
	}
    }

.menu.file.m add command -label ReconsultAux\
    -command {
	set filename [tk_getOpenFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_regex:fsa_reconsult_aux_file('$filename'))
	}
    }

.menu.file.m add separator

.menu.file.m add command -label SaveAs -underline 0 \
    -command {
	set filename [tk_getSaveFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename'))
	}
    }

.menu.file.m add command -label "SaveAsPsTricks Picture" \
    -command {
	set filename [tk_getSaveFile -defaultextension .pic]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',pstricks))
	}
    }

.menu.file.m add command -label "SaveAsPsTricks LaTeX Document" \
    -command {
	set filename [tk_getSaveFile -defaultextension .tex]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',pstricks_tex))
	}
    }

.menu.file.m add command -label SaveAsPostScript\
    -command {
	set filename [tk_getSaveFile -defaultextension .ps]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',postscript))
	}
    }

.menu.file.m add command -label SaveAsFast\
    -command {
	set filename [tk_getSaveFile -defaultextension .fast]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',fast))
	}
    }

.menu.file.m add command -label SaveAsNormal\
    -command {
	set filename [tk_getSaveFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',normal))
	}
    }


.menu.file.m add command -label SaveAsOld\
    -command {
	set filename [tk_getSaveFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',old))
	}
    }

.menu.file.m add command -label SaveAsCompact\
    -command {
	set filename [tk_getSaveFile]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',compact))
	}
    }

.menu.file.m add command -label SaveAsVcg\
    -command {
	set filename [tk_getSaveFile -defaultextension .vcg]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',vcg))
	}
    }

.menu.file.m add command -label SaveAsDaVinci\
    -command {
	set filename [tk_getSaveFile -defaultextension .dav]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',davinci))
	}
    }

.menu.file.m add command -label SaveAsDot\
    -command {
	set filename [tk_getSaveFile -defaultextension .dot]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',dot))
	}
    }

.menu.file.m add command -label SaveAsProlog\
    -command {
	set filename [tk_getSaveFile -defaultextension .pl]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',prolog))
	}
    }

.menu.file.m add command -label {SaveAsC}\
    -command {
	set filename [tk_getSaveFile -defaultextension .c]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',c))
	}
    }

.menu.file.m add command -label {SaveAsJava}\
    -command {
	set filename [tk_getSaveFile -defaultextension .java]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',java))
	}
    }

.menu.file.m add command -label {SaveAsC++}\
    -command {
	set filename [tk_getSaveFile -defaultextension .cc]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',cpp))
	}
    }

.menu.file.m add command -label SaveAsFSM\
    -command {
	set filename [tk_getSaveFile -defaultextension .fsm]
	if {"$filename" != ""} {
	    prolog protect(fsa_tk:save_fsa('$filename',fsm))
	}
    }

.menu.file.m add separator

.menu.file.m add command -label Revert -underline 0\
	-command { prolog protect(fsa_tk:revert_fsa(started($interp))) }

.menu.file.m add command -label Redraw -underline 2\
	-command { prolog protect(fsa_tk:recreate_fsa(started($interp))) }

.menu.file.m add separator

.menu.file.m add command -label Close -underline 0\
    -command { prolog fsa_tk:tk_close($interp) }

.menu.file.m add command -label Quit -underline 0\
	-command exit

# .menu.options is filled in from the Prolog side

foreach op { 
    accessible
    cleanup
    coaccessible
    complement
    complete
    containment
    del
    determinize 
    dict
    domain
    efree
    reachable_efree
    co_reachable_efree
    expand_non_overlapping_predicates
    kleene_star
    kleene_plus
    identity
    ins
    inverse
    letter_transducer
    minimize
    mb
    mh
    no_weights
    option
    perfect_hash
    range
    reverse
    subs
    t_determinize
    t_minimize
    w_determinize
    w_minimize
    weights
    weighted_letter_transducer
    wt_determinize
    wt_minimize
           } {
    .menu.op.m add command -label $op -command "
    prolog \"protect(fsa_tk:tk_operation($op,started($interp)))\" "
#    prolog \"tk_regex('$op\(\$regex\)',started('.t.c'))\" "
}

foreach viz {
    davinci
    dotty
    dot_ghostview
    dot_gv
    dot_xv
    vcg
} { .menu.viz.m add command -label $viz \
	-command "prolog protect(fsa_visualization:fsa_visualization($viz))"
}

.menu.viz.m add command -label Internal -command "prolog display_fa"
.menu.viz.m add command -label {Tk (ignoring no_display_beyond)} -command \
              "prolog tk_fsa_anyway(started($interp))"

.menu.pro.m add command -label {Produce in order of length}\
    -command "prolog protect(fsa_tk:produce_order_of_length)"
.menu.pro.m add command -label {Stochastic Sample}\
    -command "prolog protect(fsa_tk:produce_stochastic_sample)"
.menu.pro.m add command -label {Minimum path}\
    -command "prolog protect(fsa_tk:fsa_minimum_path)"

.menu.help.m add command -label About -command {
    prolog fsa_tk:tk_version($interp)
}
.menu.help.m add command -label {Reference Manual in netscape}\
	-command {
         send_url_to_netscape http://www.let.rug.nl/~vannoord/Fsa/Manual
                 }

.menu.help.m add command -label {FSA Home Page}\
	-command {
         send_url_to_netscape http://www.let.rug.nl/~vannoord/Fsa/
                 }

pack .menu.file .menu.options .menu.op .menu.pro .menu.viz -side left
pack .menu.help -side right


frame .edits
label .edits.al -text {Edge Angle:}
entry .edits.a -textvariable fsa(angle) -relief sunken -width 5\
        -font $entryfont
bind .edits.a <Return> "
   prolog \"protect(fsa_globals:fsa_global_set(v_angle,\$fsa(angle)))\"
   prolog \"protect(fsa_tk:recreate_fsa(started($interp)))\" "
label .edits.xl -text {X-distance:}
entry .edits.x -textvariable fsa(xdist) -relief sunken -width 5\
        -font $entryfont
bind .edits.x <Return> "
	prolog protect(fsa_globals:fsa_global_set(v_xdist,\$fsa(xdist)))
	prolog \"protect(fsa_tk:revert_fsa(started($interp)))\""

button .edits.sigma -text {Display Sigma} \
         -command "prolog protect(fsa_tk:display_sigma)"

button .edits.fa -text {Display Fa} -command "prolog protect(fsa_tk:display_fa)"

button .edits.count -text {Count Fa} -command "prolog protect(fsa_tk:count_fa)"

button .edits.cache -text {Clear Cache} -command "prolog fsa_regex:verbose_clear_cache"

button .edits.zoomin -text {Zoom-out} -command "prolog fsa_tk:zoom(0.8,$interp)"

button .edits.zoomout -text {Zoom-in} -command "prolog fsa_tk:zoom(1.125,$interp)"
button .edits.interp -text {Interp} -command {prolog "format('~w~n',\[$interp\])"}

pack .edits.al .edits.a .edits.xl .edits.x \
    .edits.sigma .edits.fa .edits.count .edits.cache \
    .edits.zoomin .edits.zoomout .edits.interp -side left -fill x
    
frame .regexf
frame .stringf
frame .t

label .regexf.regexl -text "Regex:"
entry .regexf.regex -textvariable regex -relief sunken -font $entryfont
bind .regexf.regex <Return> {
    regsub -all ' $regex "\\\\'" regex
    prolog "protect(fsa_tk:tk_regex('$regex',started($interp)))"
}
bind .regexf.regex <Up> {
    if [expr $current_cmd_no > 1] {
	set current_cmd_no [expr $current_cmd_no-1]
	set regex $regex_history($current_cmd_no);
    }
}
bind .regexf.regex <Down> {
    if [expr $current_cmd_no < $last_cmd_no] {
	set current_cmd_no [expr $current_cmd_no+1]
	set regex $regex_history($current_cmd_no)
    }
}
bind .regexf.regex <3> "set regex {}"

button .regexf.expanduser -text {Expand User Macro's}\
    -command {prolog "protect(fsa_tk:expand_user_macros('$regex',$interp))"}

button .regexf.expandall -text {Expand All Macro's}\
    -command {prolog "protect(fsa_tk:expand_all_macros('$regex',$interp))"}

pack .regexf.regexl -side left
pack .regexf.regex -side left -expand 1 -fill x
pack .regexf.expanduser .regexf.expandall -side left

label .stringf.stringl -text "String:"
entry .stringf.string -textvariable string -relief sunken -width 60\
      -font $entryfont
bind .stringf.string <Return> {
    set string_last_cmd_no [expr $string_last_cmd_no+1]
    set string_current_cmd_no $string_last_cmd_no
    set string_history($string_last_cmd_no) $string
    prolog protect(fsa_tk:submit_from_tk(\'$action\',\"$string\"))
}
bind .stringf.string <Up> {
    if [expr $string_current_cmd_no > 1] {
	set string_current_cmd_no [expr $string_current_cmd_no-1]
	set string $string_history($string_current_cmd_no);
    }
}
bind .stringf.string <Down> {
    if [expr $string_current_cmd_no < $string_last_cmd_no] {
	set string_current_cmd_no [expr $string_current_cmd_no+1]
	set string $string_history($string_current_cmd_no)
    }
}
bind .stringf.string <3> "set string {}"

set action {Apply Exactly}
menubutton .stringf.actiontype -menu .stringf.actiontype.menu -textvariable action -relief raised
menu .stringf.actiontype.menu 

.stringf.actiontype.menu add radiobutton -label {Apply Exactly}\
    -variable action
.stringf.actiontype.menu add radiobutton -label {Apply Approximately}\
    -variable action

button .stringf.submit -text {Submit} -command {
    set string_last_cmd_no [expr $string_last_cmd_no+1]
    set string_current_cmd_no $string_last_cmd_no
    set string_history($string_last_cmd_no) $string
    prolog protect(fsa_tk:submit_from_tk(\'$action\',\"$string\"))
}



pack .stringf.stringl -side left 
pack .stringf.string -side left -expand 1 -fill x
pack .stringf.submit .stringf.actiontype -side left
##pack .stringf.accept .stringf.transduce .stringf.w_transduce .stringf.approx -side left

canvas .t.c -bd 2 -yscrollcommand ".t.y set" \
	-xscrollcommand ".t.x set" \
	-background White\
	-scrollregion "-5000 -5000 5000 5000" -width 0 -height 0

scrollbar .t.x -orient horiz -command ".t.c xview"
scrollbar .t.y -command ".t.c yview"
pack .t.x -side bottom -fill x
pack .t.y -side left -fill y
pack .t.c -fill both -expand 1

pack .menu -side top -fill x
pack .regexf -fill x
pack .stringf -fill x
pack .t -fill both -expand 1
pack .edits -fill x -expand 0


proc next_regex {lregex} {
    global regex_history regex current_cmd_no last_cmd_no
    set regex $lregex
    set last_cmd_no [expr $last_cmd_no+1]
    set current_cmd_no $last_cmd_no
    set regex_history($last_cmd_no) $lregex

}

bind .t.c <1> "tk_popup .menu.file.m %X %Y"
bind .t.c <2> "tk_popup .menu.op.m %X %Y"
bind .t.c <3> "tk_popup .menu.viz.m %X %Y"

proc move_node {state x y} {
    global interp
     prolog "protect(fsa_tk:move_node0($state,$x,$y,$interp))"
}

proc edge-label {canvas name x y text tag {anchor center}} {
    label $name -text $text -relief raised \
   -font "-*-times-bold-r-*-*-*-120-*-*-*-*-*-*"
   bind $name <Enter> "myraise $name $canvas \{$tag\}"
   bind $name <1> "showtrans \{$tag\}"
   $canvas create window $x $y -window $name -anchor $anchor
}

proc showtrans {tag} {
    prolog fsa_tk:showtrans([lindex $tag 0],[lindex $tag 1])
}

proc myraise {w canvas tag} {
    raise $w
    $canvas itemconfigure $tag -fill red -width 3
    after 1000 "$canvas itemconfigure \{$tag\} -fill black -width 1" 
}


proc send_url_to_netscape {url} {
    if [catch { exec netscape -remote openURL($url) } ] {
	exec netscape $url &
    }
}
